import { AxiosRequestConfig } from "axios";
export declare const HTTP_CLIENT_FEATURE: unique symbol;
/**
 * Base class that extends AxiosInstance.
 * - Any class that extends this will inherit all Axios methods.
 */
export declare class AxiosHttpClient {
    private readonly instance;
    constructor(config: AxiosRequestConfig);
    getUri: (config?: AxiosRequestConfig) => string;
    request: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(config: AxiosRequestConfig<D>) => Promise<R>;
    get: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, config?: AxiosRequestConfig<D>) => Promise<R>;
    delete: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, config?: AxiosRequestConfig<D>) => Promise<R>;
    head: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, config?: AxiosRequestConfig<D>) => Promise<R>;
    options: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, config?: AxiosRequestConfig<D>) => Promise<R>;
    post: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, data?: D, config?: AxiosRequestConfig<D>) => Promise<R>;
    put: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, data?: D, config?: AxiosRequestConfig<D>) => Promise<R>;
    patch: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, data?: D, config?: AxiosRequestConfig<D>) => Promise<R>;
    defaults: Omit<import("axios").AxiosDefaults<any>, "headers"> & {
        headers: import("axios").HeadersDefaults & {
            [key: string]: import("axios").AxiosHeaderValue;
        };
    };
    interceptors: {
        request: import("axios").AxiosInterceptorManager<import("axios").InternalAxiosRequestConfig>;
        response: import("axios").AxiosInterceptorManager<import("axios").AxiosResponse>;
    };
    postForm: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, data?: D, config?: AxiosRequestConfig<D>) => Promise<R>;
    putForm: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, data?: D, config?: AxiosRequestConfig<D>) => Promise<R>;
    patchForm: <T = any, R = import("axios").AxiosResponse<T, any>, D = any>(url: string, data?: D, config?: AxiosRequestConfig<D>) => Promise<R>;
}
//# sourceMappingURL=types.d.ts.map