"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AxiosHttpClient = exports.HTTP_CLIENT_FEATURE = void 0;
const axios_1 = __importDefault(require("axios"));
exports.HTTP_CLIENT_FEATURE = Symbol("HTTP-Client-Feature");
/**
 * Base class that extends AxiosInstance.
 * - Any class that extends this will inherit all Axios methods.
 */
class AxiosHttpClient {
    // The Axios instance itself
    instance;
    constructor(config) {
        this.instance = axios_1.default.create(config);
        Object.assign(this, this.instance); // Copy methods from instance
    }
    // These are required to satisfy the AxiosInstance contract
    getUri = this["instance"].getUri;
    request = this["instance"].request;
    get = this["instance"].get;
    delete = this["instance"].delete;
    head = this["instance"].head;
    options = this["instance"].options;
    post = this["instance"].post;
    put = this["instance"].put;
    patch = this["instance"].patch;
    defaults = this["instance"].defaults;
    interceptors = this["instance"].interceptors;
    postForm = this["instance"].postForm;
    putForm = this["instance"].putForm;
    patchForm = this["instance"].patchForm;
}
exports.AxiosHttpClient = AxiosHttpClient;
